#!/bin/bash

TARGET=$(cat ../../../Target)
BUILD=$(cd ../../../Build/lib/ && pwd)

#
# Stripping and signing libav libraries.
#

if [ "$TARGET" = "Linux32" ] || [ "$TARGET" = "Linux64" ];
then
  strip "${BUILD}/libav.so"

elif [ "$TARGET" = "MinGW" ]
then
  strip -p "${BUILD}/libav.dll"

  ../../../Client/Packages/nxrunner/OS/windows/scripts/sign_bins_and_libs.sh ../../../Build/lib/libav.dll

elif [ "$TARGET" = "MacOSX" ]
then
  NX_APPLE_SIGN_SCRIPT="../../../Client/Packages/nxrunner/OS/mac/common/pkgscripts/signFiles"
  NX_APPLE_SIGN_LOGFILE="sign.log"
  NX_CERTIFICATE_IDENTITY="493C5JZAGR"
  NX_CERTIFICATE_KEYCHAIN="/Library/Keychains/System.keychain"

  COMMAND_CODESIGN=$(which codesign 2> /dev/null)

  strip  "${BUILD}/libav.dylib"
  strip -x "${BUILD}/libav.dylib"

  ${NX_APPLE_SIGN_SCRIPT} "${COMMAND_CODESIGN}" "${NX_APPLE_SIGN_LOGFILE}" "${NX_CERTIFICATE_IDENTITY}" "${NX_CERTIFICATE_KEYCHAIN}" "${BUILD}/libav.dylib"
fi



